function point_direction(x1, y1, x2, y2)
	return math.deg(math.atan2((y1 - y2), (x1 - x2)))
end

function point_direction_vec(pointA, pointB)
	--Returns the direction from Vector A to Vector B.
	return math.atan2(pointA.Y - pointB.Y, pointA.X - pointB.X)
end

function Create(self)
	self.LakeBouyancy = 0.40
	self.LakeDamping = 1.1
	WaterHeight = self.Pos.Y
	self.Frame = 1
	for actor in MovableMan.Particles do
		if string.find(actor.PresetName, "Water Element") and actor.ID ~= self.ID then
			actor.ToDelete = true
			local Activ = ActivityMan:GetActivity()
			Activ:SetTeamFunds(Activ:GetTeamFunds(self.Team) + 1000, self.Team)
		end
	end
	self.Test = true
	self.Time = false
	self.gravtest = CreateMOPixel("Grav check Waterunaffected")
	self.gravtest.Pos = self.Pos
	self.TestPos = self.Pos
	MovableMan:AddParticle(self.gravtest)
	Grav = 1
end

function Update(self)
	if self.Test and self.Time then
		Grav = (self.gravtest.Pos.Y - self.TestPos.Y) / 0.111
		self.gravtest.ToDelete = true
		self.Test = false
	end
	self.Time = true
	local WaterHeightLocal = WaterHeight
	for actor in MovableMan.Actors do
		if
			actor.Pos.Y > WaterHeightLocal
			and actor.ClassName ~= "ADoor"
			and not string.find(actor.PresetName, "Door")
			and not string.find(actor.PresetName, "Teleporter")
			and actor.Sharpness ~= 2
		then
			if actor:IsPlayerControlled() == false and actor:GetAimAngle(false) < -1 then
				actor:GetController():SetState(Controller.BODY_CROUCH, true)
			end
			if
				math.random(0, 30 / (1 + (actor.Vel.X ^ 2 + actor.Vel.Y ^ 2) ^ 0.5)) == 0
				and (actor.Vel.X ^ 2 + actor.Vel.Y ^ 2) ^ 0.5 > 1
			then
				--Create the particle.
				local part = CreateMOPixel("Water Shift")
				--Set the particle's position to just over the actor's head.
				part.Pos = actor.Pos
					+ Vector(math.random(-25, 25) * 0.01 * actor.Diameter, math.random(-25, 25) * 0.01 * actor.Diameter)
				part.Vel = actor.Vel * (math.random(0, 75) * 0.005)
				--Add the particle to the world.
				MovableMan:AddParticle(part)
			end
			if actor.ClassName ~= "ACrab" then
				if actor.ClassName ~= "ACRocket" then
					if actor:GetController():IsState(Controller.MOVE_RIGHT) then
						actor.Vel.X = actor.Vel.X + 0.2
					end
					if actor:GetController():IsState(Controller.MOVE_LEFT) then
						actor.Vel.X = actor.Vel.X - 0.2
					end
					if actor:GetController():IsState(Controller.BODY_JUMP) then
						actor.Vel.Y = actor.Vel.Y - 0.2
					end
					actor.Vel.X = actor.Vel.X * 0.925
					if not actor:GetController():IsState(Controller.BODY_CROUCH) then
						actor.Vel.Y = actor.Vel.Y * 0.925
						actor.Vel.Y = actor.Vel.Y - self.LakeBouyancy * Grav
						--		elseif actor.Pos.Y < 969 then
						--			actor.Vel.Y = actor.Vel.Y - (self.LakeBouyancy * (actor.Pos.Y - 869) / 100);
					else
						actor.Vel.Y = actor.Vel.Y + (2 / (actor.Vel.Y ^ 2 + 20 + actor.Vel.X ^ 2))
						if actor.Vel.Y > 0 then
							actor.Vel.Y = actor.Vel.Y * 0.98
						else
							actor.Vel.Y = actor.Vel.Y * 0.925
						end
						actor.Vel.Y = actor.Vel.Y
							- (
									self.LakeBouyancy
									/ ((actor:GetAltitude(35, 3) / ((actor.Pos.Y - (WaterHeightLocal - 400)) / 200)) ^ 0.8 + 1)
									* 6.5
								)
								* Grav
						--			else
						--				actor.Vel.Y = actor.Vel.Y - self.LakeBouyancy
					end
				else
					actor.Vel = actor.Vel * 0.925
				end
			else
				actor.Vel = actor.Vel * 0.925
				self.AngularVel = self.AngularVel - ((self.RotAngle + self.AngularVel) * 0.1)
				if actor:GetController():IsState(Controller.MOVE_RIGHT) then
					actor.Vel.X = actor.Vel.X + 0.15
				end
				if actor:GetController():IsState(Controller.MOVE_LEFT) then
					actor.Vel.X = actor.Vel.X - 0.15
				end
				if actor:GetController():IsState(Controller.BODY_JUMP) then
					actor.Vel.Y = actor.Vel.Y - 0.2
				end
			end
			actor.AngularVel = actor.AngularVel * 0.9
		end
		if
			actor.Pos.Y < WaterHeightLocal
			and actor.Pos.Y > WaterHeightLocal - 16
			and not string.find(actor.PresetName, "Teleporter")
		then
			if actor.Vel.Y > 0 then
				if actor.Vel.Y > 4 then
					local Check = true
					for actor in MovableMan.Particles do
						if
							string.find(actor.PresetName, "Water Splash Sound 3 Emitter")
							or string.find(actor.PresetName, "Water Splash Sound 2 Emitter")
							or string.find(actor.PresetName, "Water Splash Sound 1 Emitter")
						then
							Check = false
						end
					end
					if Check == true then
						if math.random(0, 2) == 0 then
							local part = CreateAEmitter("Water Splash Sound 3 Emitter")
							part.Pos = actor.Pos
							part.Vel = actor.Vel
							MovableMan:AddParticle(part)
						elseif math.random(0, 1) == 0 then
							local part = CreateAEmitter("Water Splash Sound 2 Emitter")
							part.Pos = actor.Pos
							part.Vel = actor.Vel
							MovableMan:AddParticle(part)
						else
							local part = CreateAEmitter("Water Splash Sound 1 Emitter")
							part.Pos = actor.Pos
							part.Vel = actor.Vel
							MovableMan:AddParticle(part)
						end
					end
				end
				local i = 1
				while i < -5 + ((actor.Vel.Y * 0.1) ^ 0.8 * 10) do
					--Create the particle.
					local part = CreateMOPixel("Water Splash")
					part.Pos = actor.Pos
						+ Vector(
							math.random(-25, 25) * 0.01 * actor.Diameter,
							math.random(-25, 25) * 0.01 * actor.Diameter
						)
					if i / 2 == math.floor(i / 2) then
						part.Vel = actor.Vel * (math.random(75, 250) * 0.003333)
							+ Vector(math.random(-75, 75) / 10, math.random(-75, 75) * 0.03333)
					else
						local speed = ((actor.Vel.X ^ 2 + actor.Vel.Y ^ 2) ^ 0.5) ^ 0.9
						local WorkingVel = Vector(
							math.cos(point_direction(0, 0, actor.Vel.X, actor.Vel.Y)),
							math.sin(point_direction(0, 0, actor.Vel.X, actor.Vel.Y))
						)
						part.Vel = Vector(
							(WorkingVel.X * math.random(75, 150) * -0.003333) + (math.random(-75, 75) * 0.001) * speed,
							(WorkingVel.Y * math.random(100, 200) / 30) + (math.random(-75, 0) * 0.001) * speed
						)
					end
					--Add the particle to the world.
					MovableMan:AddParticle(part)
					i = i + 1
				end
				if actor.Sharpness ~= 2 then
					actor.Vel.Y = actor.Vel.Y ^ 0.9
				end
			else
				if actor.Vel.Y < -6 then
					local Check = true
					for actor in MovableMan.Particles do
						if
							string.find(actor.PresetName, "Water Splash Sound 3 Emitter")
							or string.find(actor.PresetName, "Water Splash Sound 2 Emitter")
							or string.find(actor.PresetName, "Water Splash Sound 1 Emitter")
						then
							Check = false
						end
					end
					if Check == true then
						--Create the particle.
						if math.random(0, 2) == 0 then
							local part = CreateAEmitter("Water Splash Sound 3 Emitter")
							MovableMan:AddParticle(part)
						elseif math.random(0, 1) == 0 then
							local part = CreateAEmitter("Water Splash Sound 2 Emitter")
							MovableMan:AddParticle(part)
						else
							local part = CreateAEmitter("Water Splash Sound 1 Emitter")
							MovableMan:AddParticle(part)
						end
					end
				end
				local i = 1
				while i < -5 + ((actor.Vel.Y * -0.1) ^ 0.8 * 10) do
					--Create the particle.
					local part = CreateMOPixel("Water Splash")
					--Set the particle's position to just over the actor's head.
					part.Pos = actor.Pos
						+ Vector(
							math.random(-25, 25) * 0.01 * actor.Diameter,
							math.random(-25, 25) * 0.01 * actor.Diameter
						)
					if i / 2 == math.floor(i / 2) then
						part.Vel = actor.Vel * (math.random(75, 250) / 300)
							+ Vector(math.random(-75, 75) * 0.1, math.random(-75, 75) * 0.0333)
					else
						local speed = ((actor.Vel.X ^ 2 + actor.Vel.Y ^ 2) ^ 0.5) ^ 0.9
						local WorkingVel = Vector(
							math.cos(point_direction(0, 0, actor.Vel.X, actor.Vel.Y)),
							math.sin(point_direction(0, 0, actor.Vel.X, actor.Vel.Y))
						)
						part.Vel = Vector(
							(WorkingVel.X * math.random(75, 150) * -0.0333) + (math.random(-75, 75) * 0.001) * speed,
							(WorkingVel.Y * math.random(100, 200) * 0.0333) + (math.random(-75, 0) * 0.001) * speed
						)
					end
					--Add the particle to the world.
					MovableMan:AddParticle(part)
					i = i + 1
				end
			end
		end
	end

	for actor in MovableMan.Items do
		if actor.Pos.Y > WaterHeightLocal then
			actor.AngularVel = actor.AngularVel * 0.8333
			actor.Vel = actor.Vel * 0.925
		end
	end

	for actor in MovableMan.Particles do
		local mass = actor.Mass
		if
			actor.Pos.Y > WaterHeightLocal
			and not string.find(actor.PresetName, "Respawn Glow")
			and not string.find(actor.PresetName, "Dispenser")
			and not string.find(actor.PresetName, "Teleporter")
		then
			actor.AngularVel = actor.AngularVel * 0.9
			if not string.find(actor.PresetName, "Water Shift") then
				actor.Vel = actor.Vel * 0.9
				actor.Vel.Y = actor.Vel.Y
					- (self.LakeBouyancy * 0.03 * ((actor.Diameter ^ 2 + 1) / (mass + (actor.Diameter ^ 2 * 0.02)))) ^ 0.7 * Grav
			end
			if
				actor.Vel.Y + math.abs(actor.Vel.X * 3) < 2
				and not string.find(actor.PresetName, "Water Splash")
				and not string.find(actor.PresetName, "Dispenser")
				and not string.find(actor.PresetName, "Teleporter")
			then
				if actor.Lifetime == 0 or actor.Lifetime > 2000 then
					if not string.find(actor.PresetName, "Waterproof") then
						if actor.Sharpness < (1 / (10 + mass)) then
							if actor.Lifetime == 0 or actor.Lifetime > 1000 * mass ^ 0.5 then
								actor.Lifetime = 500 * mass ^ 0.5
							end
						else
							actor.Sharpness = actor.Sharpness - (math.random(1, 5) * 0.001 / mass ^ 0.5)
							actor.Sharpness = actor.Sharpness / ((math.random(5, 10) * 0.01 / mass ^ 0.5) + 1)
						end
					end
				end
			end
		end
		if
			actor.Pos.Y < WaterHeightLocal
			and not string.find(actor.PresetName, "Respawn Glow")
			and actor.Pos.Y > WaterHeightLocal - 16
			and not string.find(actor.PresetName, "Water Splash")
			and not string.find(actor.PresetName, "Teleporter")
		then
			if Remove == 1 then
				if actor.Vel.Y < 0 then
					if actor.Sharpness < (1 / (10 + mass)) and not string.find(actor.PresetName, "Waterproof") then
						if actor.Lifetime == 0 or actor.Lifetime > 1000 * mass ^ 0.5 then
							actor.Lifetime = 500 * mass ^ 0.5
						end
					else
						actor.Sharpness = actor.Sharpness - (math.random(1, 5) * 0.01 / mass ^ 0.5)
						actor.Sharpness = actor.Sharpness / ((math.random(5, 10) * 0.01 / mass ^ 0.5) + 1)
					end
				else
					actor.Vel.Y = actor.Vel.Y ^ 0.9
				end
			end
		end
	end
end
